
Oc_EventHandler Bindtags FileLogger FileLogger
Oc_Class FileLogger {
    common filename ""

    proc Log {msg type src} {
	global errorInfo errorCode
	regsub -- "\n+\$" $msg {} msg ;# Strip trailing newlines, if any.
	catch {
	    set text "\n----------- "
	    append text [clock format [clock seconds] -format "%Y-%b-%d %T"]
	    append text "\n[Oc_Main GetInstanceName] $src $type:\n$msg"
	    if {![string match info $type]} {
		append text "\n-----------"
		append text "\nStack:\n$errorInfo\n-----------\n"
                append text "Additional info: $errorCode"
            }
	    puts stderr $text
	    flush stderr
	}
	if {[string match "" $filename]} {return}
        if {[catch {open $filename a} chanid]} {
             puts stderr "Error in FileLogger: unable to\
                        open error log file $filename: $chanid"
        } else {
	    set instanceinfo [Oc_Main GetInstanceName]
	    set iipid [lindex $instanceinfo 0]
	    set iiname [lrange $instanceinfo 1 end]
            catch {
		puts $chanid "\n\[$iipid [clock format [clock seconds] \
			-format %H:%M:%S\ %Y-%m-%d]\] $iiname $src $type:\n$msg"
		if {![string match info $type]} {
		    set text "-----------\n"
		    append text "Stack:\n$errorInfo\n-----------\n"
		    append text "Additional info: $errorCode"
		    puts $chanid $text
		}
	    }
            close $chanid
        }
    }

    proc SetFile {name} {
	# Use name == "" to disable file logging.  This proc will
	# create the file if it does not already exist.
	# NOTE: Might want to change this in the future to use a
	#  filename stack with PushFile and PopFile member functions,
	#  to allow code to temporarily change (and unchange) logging
	#  file.
	if {[catch {open $name a+} chanid]} {
	    if {0} {
		# Disable error message for beta release.  This
		# should be tied to a global "debug" level.
		Oc_Log Log "Error in FileReport: unable to\
			open error log file $name: $chanid" error
		# Should we set filename to "", or leave it
		# pointing to wherever it was last?  Changing it
		# is arguably correct, but leaving it alone is
		# probably safer and more useful.
	    }
	} else {
	    close $chanid
	    set filename $name
	}
    }

    proc GetFile {} {
	return $filename
    }

    Constructor {args} {
	return -error "$class does not create instances"
    }
}

